#!/usr/bin/python

import re
import sys
import os
import signal
from enum import Enum
from subprocess import Popen, PIPE
from pyparsing import nestedExpr
import pyparsing as pp
import re
import time
import uuid

modelFile = ""
k=0
kwFile = ""
tempdirectory = "temp"

def generate_kw_model(k, model):
    global tempdirectory
    print("generating k-witness model......")
    exe = sys.path[0] + "/aigcertify_kind "
    kflag = "-k " + str(k) + " "
    f = " " + sys.path[0] + "/" + model.name + " "
    outfile = tempdirectory + "/kw-" + str(uuid.uuid4()) + ".aag"

    cmd = exe + kflag + "-o " + outfile + f
    print("cmd: ", cmd)

    signal.signal(signal.SIGPIPE, signal.SIG_IGN);

    p = Popen(cmd, shell=True, stdout=PIPE)
    output = p.communicate()[0]
    output = output.splitlines()

    return outfile

def fuzz():
    global tempdirectory
    print("generating aiger model by aigfuzz......")
    exe = sys.path[0] + "/aiger/aigfuzz "
    flag = "-s -S -m -a -1 "
    outfile = tempdirectory + "/fuzz-" + str(uuid.uuid4()) + ".aag"

    cmd = exe + flag + "-o " + outfile
    print("cmd: ", cmd)

    signal.signal(signal.SIGPIPE, signal.SIG_IGN);

    p = Popen(cmd, shell=True, stdout=PIPE)
    output = p.communicate()[0]

    return outfile

def mcaiger(model_file):
    global tempdirectory
    print("checked by mcaiger......")
    exe = sys.path[0] + "/mcaiger/mcaiger "
    flag = "-n "
    f = " " + sys.path[0] + "/" + model_file + " "

    cmd = exe + flag + f
    print("cmd: ", cmd)

    signal.signal(signal.SIGPIPE, signal.SIG_IGN);

    p = Popen(cmd, shell=True, stdout=PIPE)
    output = p.communicate()[0]
    output = output.splitlines()
    print("mcaiger output:")
    k = output[-1].decode('utf8')
    if(output[-2].decode('utf8') == "1" or k== "k=1" or k=="k=0"):
        exe1 = "cd " + sys.path[0] + "/temp \n"
        exe2 = " rm -rf " + f
        cmd1 = exe1 + exe2
        return -1
    else:
        print(output[-1])
        print("found a k-inductive model!")
        return output[-1]


############ main #############


while(True):
    f = fuzz()
    res = mcaiger(f)
    if res != -1:
        break
